modules/material/models/Comment.php
<?php

namespace app\modules\material\models;

use Yii;
use yii\data\ActiveDataProvider;

use app\models\User;
use yii\helpers\ArrayHelper;
use app\components\Settings;
use app\models\ActiveRecord;

/**
 * This is the model class for table "comment".
 *
 * @property integer $id
 * @property integer $id_material
 * @property integer $id_comment
 * @property integer $id_user
 * @property string $text
 * @property string $date_created
 * @property integer $is_show
 */
class Comment extends ActiveRecord {

    /**
     * @inheritdoc
     */
    public function rules() {
        return [
            ['is_show', 'default', 'value' => 1],
            [['id_material', 'id_user', 'text', 'date_created', 'is_show'], 'required'],
            [['id_material', 'id_comment', 'id_user', 'is_show'], 'integer'],
            [['text'], 'string'],
            [['id_material', 'id_user', 'text', 'date_created'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels() {
        return [
            'id' => 'ID',
            'id_material' => Yii::t(Settings::getInstance()->getModuleId(), 'Material'),
            'id_comment' => Yii::t('material', 'Answer'),
            'id_user' => Yii::t('material', 'User'),
            'text' => Yii::t('material', 'Text'),
            'date_created' => Yii::t('material', 'Date'),
            'is_show' => Yii::t('material', 'Is Show'),
        ];
    }
    
    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUser() {
        return $this->hasOne(User::className(), ['id' => 'id_user']);
    }
    
    public function getMaterial() {
        $class = Settings::getInstance()->getModulePath()."\models\Material";
        return $this->hasOne($class::className(), ['id' => 'id_material']);
    }
    
    public function testObject() {
        $class_material = Settings::getInstance()->getModulePath()."\models\Material";
        $class_comment = Settings::getInstance()->getModulePath()."\models\Comment";
        if (intval($this->id_material) && !$class_material::find()->where(["id" => $this->id_material])->count())
            $this->addError ("id_material", Yii::t('material', 'Material not found'));
        if (intval($this->id_user) && !User::find()->where(["id" => $this->id_user])->count())
            $this->addError ("id_user", Yii::t('material', "User not found"));
        if (!empty($this->id_comment) && !$class_comment::find()->where(["id" => $this->id_comment, "id_material" => $this->id_material])->count())
            $this->addError ("id_comment", Yii::t('material', "Comment not found"));
    }
    
    public function afterValidate() {
        parent::afterValidate();
        $this->testObject();
    }

    public function search($params, $id_object = false) {
        $query = static::find();
        if ($id_object)
            $query->andWhere(["id_material" => $id_object]);

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => ['pageSize' => 50],
        ]);
        
        $dataProvider->sort = ['defaultOrder' => ['id'=>SORT_DESC]];

        if (!($this->load($params) && $this->validate())) {
            return $dataProvider;
        }

        $query->andFilterWhere(['id_material' => $this->id_material]);
        $query->andFilterWhere(['id_comment' => $this->id_comment]);
        $query->andFilterWhere(['id_user' => $this->id_user]);
        $query->andFilterWhere(['like', 'text', $this->text]);
        $query->andFilterWhere(['like', 'date_created', $this->date_created]);
        $query->andFilterWhere(['is_show' => $this->is_show]);

        return $dataProvider;
    }
    
    //Сортировка комментариев в виде дерева
    private static function sortComments($list = []) {
        //Сортируем список на дочерние и родительские
        $chields = [];
        $comments = [];
        foreach ($list as $id => &$item) {
            if (empty($item['id_comment'])) {
                $item['level'] = 1;
                $comments[] = $item;
            } else
                $chields[] = $item;
        }
        //Раскидываем дочерние элементы по родительским
        foreach ($chields as $item) {
            static::putChieldItem($comments, $item);
        }
        return $comments;
    }

    //Рекурсия. Ходит по дереву, исипользуется для сортировки
    private static function putChieldItem(&$list, &$subitem, $level = 1) {
        foreach ($list as $key => &$item) {
            if ($item['id'] == $subitem['id_comment']) {
                $subitem['level'] = $level + 1;
                $item['items'][] = $subitem;
                return true;
            } else if (isset($item['items']) && is_array($item['items'])) {
                if (static::putChieldItem($item['items'], $subitem, $level + 1))
                    return true;
            } else
                continue;
        }
        return false;
    }

    //Выдает комментарии для новости в виде сортированного дерева
    public static function getSortedCommentsList($id = false) {
        $comments = static::findAll(["id_material" => $id]);
        $list = [];
        foreach ($comments as $comment)
            $list[$comment['id']] = $comment->fieldsValue();
        $list = static::sortComments($list);
        return $list;
    }


    //Из дерева комментариев вытаскивает уровни каждого и формирует одномерный
    //массив в виде айдишника комментария и его уровень
    public static function getCommentsLevel($list = [], &$levels = []) {
        foreach ($list as $item) {
            $levels[$item['id']] = $item['level'];
            if (isset($item['items']) && is_array($item['items']))
                static::getCommentsLevel($item['items'], $levels);
        }
        return $levels;
    }

    //Использует метод getSortedCommentsList;
    //Формирует в массив первого уровня из вложенных элементов
    public static function getCommentsList($list = [], &$list1 = []) {
        foreach ($list as &$item) {
            $list1[$item['id']] = $item;
            if (isset($item['items']) && is_array($item['items'])) {
                static::getCommentsList($item['items'], $list1);
                unset($list1[$item['id']]['items']);
            }
        }
        return $list1;
    }

    public static function getChieldComments($id = false, $id_comment = false, $list = false, &$ids = []) {
        if (!$list)
            $list = static::getSortedCommentsList($id);
        foreach ($list as $item) {
            if ($item['id_comment'] == $id_comment || $item['id'] == $id_comment)
                $ids[] = $item['id'];
            if (isset($item['items']) && is_array($item['items'])) {
                static::getChieldComments($id, $item['id'], $list, $ids);
            }
        }
        return $ids;
    }
    
    public static function getMainComments($count = 10) {
        $class = Settings::getInstance()->getModulePath()."\models\Material";
        return static::find()->select(["DISTINCT `id_material`", "id", "text"])->where(["id_comment" => NULL, "is_show" => 1])->orderBy("`date_created` DESC")->limit($count)->all();
    }

    public function formatDate($timestamp = false) {
        if (!$timestamp)
            $timestamp = strtotime($this->date_created);
        if (!$timestamp)
            return "";
        $datetime1 = new \DateTime('@' . time());
        $datetime2 = new \DateTime('@' . $timestamp);
        $interval = $datetime1->diff($datetime2);

        $years = $interval->format('%y');
        $months = $interval->format('%m');
        $days = $interval->format('%a');
        $hours = $interval->format('%h');
        $minutes = $interval->format('%i');
        $seconds = $interval->format('%S');

        $elapsed = "Now";
        if ($seconds && $seconds != "00"):
            $elapsed = $seconds == 1 ? $seconds . ' Second ' : $seconds . ' Seconds ';
        endif;
        if ($minutes):
            $elapsed = $minutes == 1 ? $minutes . ' Minute ' : $minutes . ' Minutes ';
        endif;
        if ($hours):
            $elapsed = $hours == 1 ? $hours . ' Hour ' : $hours . ' Hours ';
        endif;
        if ($days):
            $elapsed = $days == 1 ? $days . ' Day ' : $days . ' Days ';
        endif;
        if ($months):
            $elapsed = $months == 1 ? $months . ' Month ' : $months . ' Months ';
        endif;
        if ($years):
            $elapsed = $years == 1 ? $years . ' Year ' : $years . ' Years ';
        endif;

        return $elapsed;
    }
    
    public function updateCount() {
        $class = Settings::getInstance()->getModulePath()."\models\Material";
        if ($model = $class::findOne(["id" => $this->id_material])) {
            $model->updateCommentsCount();
        }
        
    }

}

modules/material/views/admin/default_with_map/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use dosamigos\tinymce\TinyMce;
use yii\web\JsExpression;
use kartik\depdrop\DepDrop;
use kartik\select2\Select2;
use yii\helpers\ArrayHelper;
use yii\helpers\Url;
use kartik\file\FileInput;
use kartik\touchspin\TouchSpin;
use app\widgets\googlemap\SelectMapLocationWidget;

use app\models\Language;
use app\components\Settings;
use app\models\WorldCountries;
use app\models\WorldCities;

//use app\modules\news\models\Section;
//use app\modules\news\models\SubSection;

$class_section = Settings::getInstance()->getModulePath()."\models\Section";
$class_subsectioin = Settings::getInstance()->getModulePath()."\models\SubSection";


$id_language = isset($id_language)?$id_language:false;
?>

<div class="col-xs-5" style="padding-left: 0px;"> 
    <?php
            
    echo $form->field($model, "[{$id_language}]id_area", [
            'template' =>  "{label} ".Html::a('', ['/admin/countries/create', "language" => Language::getTypeOfLanguage($model->id_language)], ['class' => 'glyphicon glyphicon-plus action-button', 'target' => "_blank"])." {input}" 
        ])->widget(Select2::classname(), [
        'options' => [
            'id'=>"area-id{$id_language}",
            'placeholder' => Yii::t('material', 'Select a country ..')
        ],
        'data' => ArrayHelper::map(WorldCountries::find()->select(['name', 'id'])->where(["id_language" => $model->id_language])->orderBy("`name` DESC")->all(), 'id', 'name')
                    
    ]);
            
    $cities = WorldCities::find()->where(["country" => $model->id_area])->asArray()->all();
    echo $form->field($model, "[{$id_language}]id_city", [
            'template' =>  "{label} ".Html::a('', ['/admin/cities/create'], ['class' => 'glyphicon glyphicon-plus action-button', 'target' => "_blank"])." {input}" 
        ])->widget(DepDrop::classname(), [
        'data' => @ArrayHelper::map($cities, 'id', 'name'),
        'options'=>['id'=>"cities-id{$id_language}"],
        'type' => DepDrop::TYPE_SELECT2,
        'select2Options'=>['pluginOptions'=>['allowClear'=>true]],
        'pluginOptions'=>[
            'depends'=>["area-id{$id_language}"],
            'placeholder'=>Yii::t('material', 'Select a subsection..'),
            'url'=>Url::to(['citieslist', "id_language" => $model->id_language])
        ]
    ]);
            
    ?>

    <?= $form->field($model, "[{$id_language}]id_language")->hiddenInput()->label(false) ?>

    <?= $form->field($model, "[{$id_language}]id_user")->hiddenInput(["value" => Yii::$app->user->id])->label(false) ?>
    
    <?php
            
    echo $form->field($model, "[{$id_language}]id_section", [
            'template' =>  "{label} ".Html::a('', ['/admin/'.Settings::getInstance()->getModuleId().'/section/create', "id_language" => $id_language], ['class' => 'glyphicon glyphicon-plus action-button', 'target' => "_blank"])." {input}" 
        ])->widget(Select2::classname(), [
        'options' => [
            'id'=>"section-id{$id_language}",
            'placeholder' => Yii::t('material', 'Select a section ..')
        ],
        'data' => ArrayHelper::map($class_section::find()->select(['name', 'id'])->where(["id_language" => $model->id_language])->orderBy("`name` DESC")->all(), 'id', 'name')
                    
    ]);
    
    $subsection = $class_subsectioin::find()->where(["id_section" => $model->id_section])->asArray()->all();
    echo $form->field($model, "[{$id_language}]id_subsection", [
            'template' =>  "{label} ".Html::a('', ['/admin/'.Settings::getInstance()->getModuleId().'/subsection/create', "id_language" => $id_language], ['class' => 'glyphicon glyphicon-plus action-button', 'target' => "_blank"])." {input}" 
        ])->widget(DepDrop::classname(), [
        'data' => @ArrayHelper::map($subsection, 'id', 'name'),
        'options'=>['id'=>"subtype-id{$id_language}"],
        'type' => DepDrop::TYPE_SELECT2,
        'select2Options'=>['pluginOptions'=>['allowClear'=>true]],
        'pluginOptions'=>[
            'depends'=>["section-id{$id_language}"],
            'placeholder'=>Yii::t('material', 'Select a subsection..'),
            'url'=>Url::to(['sublist'])
        ]
    ]);
    ?>
    
    <?= $form->field($model, "[{$id_language}]date_public")->widget(\yii\jui\DatePicker::classname(), [
        'language' => 'ru',
        'dateFormat' => 'yyyy-MM-dd',
    ]) ?>
</div>
<div class="col-xs-7">
    <?php
    echo $form->field($model, "[{$id_language}]adress")->widget(SelectMapLocationWidget::className(), [
        'attributeLatitude' => "[{$id_language}]latitude",
        'attributeLongitude' => "[{$id_language}]longitude",
        'wrapperOptions' => ["style" => ["height" => "300px"]],
    ]);
    ?>
</div>

    <?php if ($model->isShow(["events", "places"])) { ?>
    <?= $form->field($model, "[{$id_language}]telephone")->textInput(); ?>

    <?= $form->field($model, "[{$id_language}]work_time")->textInput(); ?>

    <?= $form->field($model, "[{$id_language}]price")->textInput(); ?>

    <?php } ?>
   
    <?= $form->field($model, "[{$id_language}]title")->textInput(); ?> 

    <?= $form->field($model, "[{$id_language}]short_text")->textArea(["rows" => 3]); ?>

    <?= 
    $form->field($model, "[{$id_language}]text")->widget(TinyMce::className(), [
        'options' => ['rows' => 10],
        'language' => 'ru',
        'clientOptions' => [
            'plugins' => [
                "advlist autolink lists link image charmap print preview hr anchor pagebreak",
                "searchreplace wordcount visualblocks visualchars code fullscreen",
                "insertdatetime media nonbreaking save table contextmenu directionality",
                "emoticons template paste textcolor colorpicker textpattern imagetools"
            ],
            'toolbar1' => "insertfile undo redo | styleselect | bullist numlist outdent indent | link image media | print code preview fullscreen",
            'toolbar2' => "fontselect fontsizeselect | bold italic | alignleft aligncenter alignright alignjustify | forecolor backcolor",
            'image_advtab' => true,
            "relative_urls" => false,
            "remove_script_host"=> false,
            'file_browser_callback'=> new yii\web\JsExpression("function(field_name, url, type, win) {
                if(type=='image') {
                    $('#upload_form_model input').val('{$model->getShortName()}');
                    $('#upload_form_object input').val({$model->id});
                    $('#upload_form input[type=file]').click();
                }
            }"),
        ],
        
    ]); 
    //$form->field($model, "[{$id_language}]text")->textarea(['rows' => 10]);
    ?>

    <?php 
    echo $form->field($model, "[{$id_language}]scenario")->hiddenInput()->label(false);
    echo $form->field($model, "[{$id_language}]image_file")->widget(FileInput::classname(), [
        'options' => [
            'accept' => 'image/*',
            //'multiple'=>true
        ],
        'pluginOptions' => [
            'showCaption' => false,
            'showRemove' => false,
            'showUpload' => false,
            'browseClass' => 'btn btn-primary btn-block',
            'browseIcon' => '<i class="glyphicon glyphicon-camera"></i> ',
            'browseLabel' =>  Yii::t('material', 'Select Photo'),
            'initialPreview'=> ($model->image_file)?Html::img($model->getThumbUploadUrl('image_file', 'preview'), ['class' => 'img-thumbnail']):false, 
            'overwriteInitial'=>true,
        ],
        'pluginEvents' => [
            "fileclear" => "function() { jQuery('#".$model->getShortName(true)."-{$id_language}-scenario').val('default');}",
            "fileloaded" => "function() { jQuery('#".$model->getShortName(true)."-{$id_language}-scenario').val('update')}",
        ],
    ]);
    echo $form->field($model, "[{$id_language}]image")->textInput(['maxlength' => true, "placeholder" => "Укажите ссылку на изображение.."])->label(false);
    ?>

    <?= $form->field($model, "[{$id_language}]video")->hiddenInput(['maxlength' => true])->label(false) ?>

    <?= $form->field($model, "[{$id_language}]site")->hiddenInput(['maxlength' => true])->label(false) ?>

    <?= $form->field($model, "[{$id_language}]seo_title")->textInput(['maxlength' => true]) ?>
    
    <?= $form->field($model, "[{$id_language}]seo_description")->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, "[{$id_language}]seo_keywords")->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, "[{$id_language}]view_count")->textInput(["value" => ($model->view_count)?$model->view_count:0]) ?>

    <?= $form->field($model, "[{$id_language}]is_show")->dropDownList(["0" => "Черновик", "1" => "Опубликована"]) ?>

    <?= $form->field($model, "[{$id_language}]is_show_in_top")->checkbox(); ?>

    <?= $form->field($model, "[{$id_language}]is_selected")->checkbox(); ?>

    <?= $form->field($model, "[{$id_language}]is_show_on_main")->checkbox(); ?>

    <?php $form->field($model, "[{$id_language}]gallery")->checkbox(); ?>

    <?php    
    echo $form->field($model, "[{$id_language}]_temp_gallery[]", [
            'template' =>  "{label} ".((!$model->isNewRecord && $model->gallery)?$model->buildSlider():false)."{input}" 
        ])->widget(FileInput::classname(), [
        'options' => [
            'accept' => 'image/*',
            'multiple'=>true
        ],
        'pluginOptions' => [
            'showRemove' => false,
            'showUpload' => false,
            'overwriteInitial'=>true,
            //'uploadUrl' => Url::to(['/site/file-upload']),
        ],
    ]);
    ?>

    <?php
    if ($model->isShowDelivery()) {
        echo $form->field($model, "[{$id_language}]delivery_date", ['template' =>  "{label} {input}".Html::a(null, null, [
            'class' => 'glyphicon glyphicon-trash',
            'style' => 'margin-left: 5px;',
            'onclick' => "$('#material-{$id_language}-delivery_date').val(''); return false;",
        ])])->widget(\yii\jui\DatePicker::classname(), [
            'language' => 'ru',
            'dateFormat' => 'yyyy-MM-dd',
        ]);
    }
    ?>

    <?= $form->field($model, "[{$id_language}]hash_tag")->textInput() ?>

    <?= $form->field($model, "[{$id_language}]tags")->textInput() ?>

    <?= $form->field($model, "[{$id_language}]rating")->widget(TouchSpin::classname(), [
        'pluginOptions' => [
            'initval' => 0.0,
            'buttonup_class' => 'btn btn-primary', 
            'buttondown_class' => 'btn btn-info', 
            'buttonup_txt' => '<i class="glyphicon glyphicon-plus-sign"></i>', 
            'buttondown_txt' => '<i class="glyphicon glyphicon-minus-sign"></i>',
            'min' => 0,
            'max' => 5,
            'step' => 0.1,
            'decimals' => 1,
            'boostat' => 5,
            'maxboostedstep' => 10,
        ],
    ]); ?>

    <?= $form->field($model, "[{$id_language}]js")->textArea() ?>

    <?= 
    $form->field($model, "[{$id_language}]date_public")->widget(\yii\jui\DatePicker::classname(), [
        'language' => 'ru',
        'dateFormat' => 'yyyy-MM-dd',
    ]);
    ?>

    <?= $form->field($model, "[{$id_language}]comment")->textInput(['maxlength' => true]) ?>

modules/material/views/admin/default_with_map/_form_comment.php
<?php
use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\helpers\ArrayHelper;
use kartik\select2\Select2;

use app\models\User;
use app\components\Settings;

//use app\modules\news\models\Comment;
$class_comment = Settings::getInstance()->getModulePath()."\models\Comment";
?>

<?php $form = ActiveForm::begin([
    'options' => ['data-pjax' => 1]
]); ?>
    <?php 
    echo $form->field($model, 'id_user')->widget(Select2::classname(), [
        'options' => [
            'id'=> $class_comment::getIdForInput(),
            'placeholder' => Yii::t('material', 'Select a user ..')
        ],
        'data' => ArrayHelper::map(User::find()->select(['first_name', 'id'])->orderBy("`first_name` ASC")->all(), 'id', 'first_name')
    ])->label(Yii::t('material', 'From user'));
    ?>
    <?= $form->field($model, 'id_comment')->hiddenInput()->label(false) ?>
    <?= $form->field($model, 'text')->textarea()->label(Yii::t('material', "Message")) ?>

    <div class="form-group">
        <?= Html::submitButton(Yii::t('common', "Create"), ['class' => 'btn btn-primary']) ?>
    </div>
<?php ActiveForm::end(); ?>

modules/material/views/admin/default_with_map/_item.php
<?php
use yii\helpers\Html;
use app\models\User;
use yii\widgets\Pjax;

use app\components\Settings;

//use app\modules\news\models\Comment;
$class_comment = Settings::getInstance()->getModulePath()."\models\Comment";

$_model = $model;
$model = new $class_comment();
$model->prepare($_model);
$username = User::getNameOfUser($model->id_user);
$user = User::findIdentity($model->id_user);
?>
<div class="comment row">
    <div class="user-box" style="margin-left: <?= isset($levels[$_model['id']])?(25 * ($levels[$_model['id']] - 1)):0 ?>px !important;">
        <?= Html::img($user->getThumbUploadUrl('avatar', 'preview'), ["width" => 47, "height" => 47, "class" => "avatar"]); ?>
    </div>
    <div class="col-md-8 _body">
        <div class="head">
            <div class="autor"><?= $username ?></div>
            <div class="date" title="<?= $model->date_created ?>"><?= $model->formatDate() ?></div>
        </div>
        <div class="text"><?= $model->text ?></div>
    </div>
    <ul class="buttons">
        <?php
        echo Html::a('<span class="glyphicon glyphicon-envelope"></span>', '#', [
            'data-toggle' => 'modal',
            'data-target' => "#commentForm",
            'data-id_comment' => $_model['id'],
            'data-title' => (strlen($model->text) > 20)?substr($model->text, 0, 19)."..":$model->text,
            //'data-pjax' => '0',
            //'class' => 'grid-action '
        ]);
        
        //$url = "?id={$model->id_material}&id_comment={$_model['id']}";
        echo Html::a('<span class="glyphicon glyphicon-trash"></span>', ["comment", "id" => $model->id_material, "id_comment" => $_model['id']], [
            'title' => Yii::t('common', "Delete"),
            'data-confirm' => Yii::t('common', 'Are you sure you want to delete this item?'),
            'data-pjax' => '0', 
            'class' => 'grid-action'
        ]);
         
        ?>
        <?php

        ?>
    </ul>
</div>

modules/material/views/admin/default_with_map/_list.php
<?php
use \yii\widgets\ListView;
use yii\bootstrap\Modal;
use \yii\web\JsExpression;
use yii\widgets\Pjax;
use yii\helpers\Html;

use app\components\Settings;
?>

<p>
<?php
//Список сообщений
Pjax::begin(['id' => '_list_message', 'options' => ['class' => 'pjax-wraper']]);
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_item',
    'viewParams' => [
        "levels" => $levels,
    ]
]);
Pjax::end();
?>
</p>

<?php

//Блок, для отправки комментария к новости
if (isset($model)) {
    if (!Yii::$app->user->isGuest) { 
        $this->registerJs(
            '$("document").ready(function(){ 
                 $("#_send_message").on("pjax:end", function() {
                     $.pjax.reload({container:"#_list_message"});
                 });
             });'
        );
        echo "<div class=\"form\">";
        Pjax::begin(['id' => '_send_message']);
        echo $this->render("_form_comment", ["model" => $model]);
        Pjax::end();
        echo "</div>";
    } else { 
?>
        To leave a comment please <?= Html::a("signup", ["/admin/signup"]); ?> or <?= Html::a("login", ["/admin/login"]); ?>
<?php 
    } 
}
?>

<?php
$_id_block = $model->getShortName(true);
//Отправка личного сообщения
Modal::begin([
    'id' => 'commentForm',
    'header' => '<h3 id="'.$_id_block.'-header"></h3>',
    'clientEvents' => [
        'show.bs.modal' => new JsExpression("function(event){
            var button = $(event.relatedTarget);
            var id_comment = button.data('id_comment');
            var title = button.data('title');
            var modal = $(this);
            modal.find('#{$_id_block}-header').text('Ответ на \"' + title + '\"');
            modal.find('#{$_id_block}-id_comment').val(id_comment);
        }"),
    ]
]);


$this->registerJs(
   '$("document").ready(function(){ 
        $("#_send_comment").on("pjax:end", function() {
            $("#commentForm").modal("hide");
            $.pjax.reload({container:"#_list_message"});
        });
    });'
);

echo "<div class=\"form\">";
Pjax::begin(['id' => '_send_comment']);
echo $this->render("_form_comment", ["model" => $model]);
Pjax::end();
echo "</div>";
Modal::end();

?>

modules/material/views/admin/default_with_map/_menu_item.php
<?php
use yii\helpers\Url;
use yii\helpers\Html;

use app\components\Settings;

//use app\modules\news\models\Material;
//use app\modules\news\models\Section;
//use app\modules\news\models\SubSection;

$class_material = Settings::getInstance()->getModulePath()."\models\Material";
$class_section = Settings::getInstance()->getModulePath()."\models\Section";
$class_subsectioin = Settings::getInstance()->getModulePath()."\models\SubSection";


if (empty($item['id']))
    return;

$link = false;
if (isset($level) && $level > 0) {
    $p = 1;
    $sub = "alert-info sub";
    $count = $class_material::find()->where(["id_subsection" => $item['id']])->count();
    if ($main = $class_subsectioin::findOne(["id" => $item['id']]))
        $link = Url::to(['/admin/'.Settings::getInstance()->getModuleId().'/subsection/update', "id" => $main->id_main, "language" => $language]);
}
else {
    $p = 0;
    $sub = "alert-success";
    $count = $class_material::find()->where(["id_section" => $item['id']])->count();
    if ($main = $class_section::findOne(["id" => $item['id']]))
        $link = Url::to(['/admin/'.Settings::getInstance()->getModuleId().'/section/update', "id" => $main->id_main, "language" => $language]);
}
?>
<div class="alert <?= $sub ?>" id="<?= $item['id'] ?>">
    <?=
    Html::a('x', ['delete-menu-item', 'id' => $item['id'], "sub" => $p, "language" => $language], [
        'data-confirm' => Yii::t('common', 'Are you sure you want to delete this item?'),
        'data-pjax' => '0', 
        'class' => 'close grid-action'
    ]);
    ?>
    <?= ($link)?Html::a($item['name']." ({$count})", $link, ["target" => "_blank"]):$item['name'] ?>
</div>

modules/material/views/admin/default_with_map/_menu_language.php
<?php
use yii\widgets\Pjax;

if (!defined("show_menu_function") and define('show_menu_function', true)) {
    function showMenu($view, $menu, $language = "ru", $level = 0) {
        $result = "";
        foreach ($menu as $item) {
            $result .= $view->render("_menu_item", [
                "item" => $item,
                "level" => $level,
                "language" => $language,
            ]);

            if (isset($item['items']) && is_array($item['items'])) 
                $result .= showMenu($view, $item['items'], $language, ($level + 1));
        }
        return $result;
    }
} 

Pjax::begin(['id' => '_menu_items_'.$language, 'options' => ['class' => 'pjax-wraper']]);
    echo showMenu($this, $menu, $language);
Pjax::end();